using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SKYPE4COMLib;
using System.Net;
using System.IO;


namespace SkypeForBots
{
    public partial class Form1 : Form
    {
        public Skype skype = new Skype();
        public SKYPE4COMLib.SkypeClass cSkype;
        public SKYPE4COMLib.IFileTransfer FT;
        private Chat chat;

        /* Nosakm global maingos */
        bool ConnectStatusChanged; // Parsjam, kad Skype klients iesldzas/izsldzas
        bool DoNotChange; // Bug FIX

        string BotStatus; // Norda konkrto Bot statusu (Online, Away, etc.)
        string FindReadBug; // Priek labkas ienkoo ziu apstrdes
        string StatusWas; // Pirms mirka statuss bija ...
        string NOWStatus; // ... bet tagad ir ...
        string SaveFile = ""; // Priek Save Conf. pogas :)

        /* Visas maisks Skype klienta <-- --> Bot saiknes veidoana */
        public Form1()
        { 
            InitializeComponent();
            
            /* Ienkoo ziu apstrdes notikums */
            skype.MessageStatus += new _ISkypeEvents_MessageStatusEventHandler(Skype_Message);

            /* Apstrdjam ienkoos zvanus un ja pieprasts noliekam trubu :) */
            skype.CallStatus += new _ISkypeEvents_CallStatusEventHandler(Skype_CallStatus);

            /* Klienta (BOT) statusa maias gadjumiem */
            skype.UserStatus += new _ISkypeEvents_UserStatusEventHandler(Skype_UserStatus);

            /* Ja kds pieprasa autorizciju BOTam */
            skype.UserAuthorizationRequestReceived += new _ISkypeEvents_UserAuthorizationRequestReceivedEventHandler(skype_UserAuthorizationRequestReceived);
        }

        /* BOTa ielde sistma, opciju saeksana */
        private void Form1_Load(object sender, EventArgs e)
        {
            /* eksjam Option logu */
            checkBox1.Checked = Properties.Settings.Default.NotAllowIncoming;
            checkBox2.Checked = Properties.Settings.Default.BringSkypeToLife;
            checkBox4.Checked = Properties.Settings.Default.NotAllowFT;
            checkBox5.Checked = Properties.Settings.Default.AcceptAR;
            checkBox6.Checked = Properties.Settings.Default.AutoSubStart;

            numericUpDown2.Value = Properties.Settings.Default.BlockUserMsg;
            numericUpDown3.Value = Properties.Settings.Default.BlockUserTime;

            if (checkBox6.Checked)
            {
                button11.Text = "Stop service";
                timer2.Enabled = true;
            }

            /* Ja ir iestatts ieldjam konfigurcijas failu */
            if (Properties.Settings.Default.AutoConf != "")
            {
                LoadConfig(Properties.Settings.Default.AutoConf);
                LoadBackup();

                checkBox3.Checked = true;
            }
            else
            {
                checkBox3.Checked = false;
            }

            /* Ieliekam reistros informciju par FT */
            ChangeFileTransfStatus(Properties.Settings.Default.NotAllowFT);
            
            /* T k BOTs startjas nosakam visus parametrus */
            ConnectStatusChanged = true;
            toolStripStatusLabel1.Text = "Connecting to Skype ...";
            BotStatus = "NR";

            pictureBox1.Image = Properties.Resources.Online;
            pictureBox1.Tag = "ON";

            /* Iestatm ziu ko atgriezt, ja nevar dabt contentu no Interneta*/
            textBox3.Text = Properties.Settings.Default.RespondToInternetError;
            button7.Enabled = false;

            /* Ko japaspj izdart pirms programma aizveras */
            FormClosing += ByeBye;
        }

        /* Ieldjam Subscription backup, ja tds protams atrodams :) */
        string LoadBackup()
        {
            if (File.Exists(@SaveFile + ".bssd"))
            {
                StreamReader Import_backup = new StreamReader(SaveFile + ".bssd");

                int ID = 0;
                while (Import_backup.Peek() >= 0)
                {
                    treeView1.Nodes[ID].Nodes[1].Tag = Convert.ToString(Import_backup.ReadLine());
                    ID++;
                }

                Import_backup.Close();
            }
            return "";
        }

        /* Meinam pieslgties viesiem atautajiem spkiem pie Skype */
        string SkypeAttaching()
        {
            try
            {
                if ((!skype.Client.IsRunning) && (checkBox2.Checked))
                {
                    skype.Client.Start(false, true);
                }
            }
            catch (Exception)
            {

            }

            try
            {
                skype.Attach(7, false);
            }
            catch (Exception)
            {

            }

            return "";
        }

        /* Novietojam BOTu Tray */
        private void Form1_Resize(object sender, System.EventArgs e)
        {
            if (FormWindowState.Minimized == WindowState)
                this.Hide();
        }

        /* Pie ienkoiem kontaktu detau pieprasjumiem, ja vajag apstiprinm ts */
        public void skype_UserAuthorizationRequestReceived(User pUser)
        {
            if (checkBox5.Checked)
            {
                pUser.IsAuthorized = true;

                write_diary("Accepted authorization request from " + pUser.Handle);
            }
        }

        /* Veicam ierakstus Reistros priek FT */
        string ChangeFileTransfStatus(bool status)
        {
            //string WriteToReg;

            if (status)
            {
                Microsoft.Win32.RegistryKey key;
                key = Microsoft.Win32.Registry.LocalMachine.CreateSubKey("SOFTWARE\\Policies\\Skype\\Phone");

                key.SetValue("DisableFileTransfer", "1");
                key.Close();
            }
            else
            {
                Microsoft.Win32.RegistryKey key;
                key = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("SOFTWARE\\Policies\\Skype\\Phone", true);
                if (key.ValueCount > 0)
                {
                    key.DeleteValue("DisableFileTransfer");
                }

                key.Close();
            }

            return "";
        }

        /* Ko izdaram, kad programma aizveras */
        public void ByeBye(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.Save(); // Saglabjam uzstdjumus
        }

        /* Notikumi, kad izmains BOTa statuss */
        public void Skype_UserStatus(TUserStatus status)
        {
            /* Prbaudm vai gadjum nav jamina pieslgties vai ieslgt Skype */
            if ((status == TUserStatus.cusOnline) || (status == TUserStatus.cusSkypeMe) || (status == TUserStatus.cusNotAvailable) || (status == TUserStatus.cusAway) || (status == TUserStatus.cusDoNotDisturb))
            {
                NOWStatus = "ON";
            }
            else
            {
                NOWStatus = "OFF";
            }

            if ((ConnectStatusChanged == false) && (StatusWas != NOWStatus))
            {
                ConnectStatusChanged = true;
                StatusWas = NOWStatus;
            }

            /* Atjaunojam BOTa statusa informciju */

            if (status == TUserStatus.cusOnline)
            {
                BotStatus = "ON";

                toolStripStatusLabel1.Image = Properties.Resources.Online;
                toolStripStatusLabel1.Text = "Online";
            }

            if (status == TUserStatus.cusSkypeMe)
            {
                BotStatus = "SM";

                toolStripStatusLabel1.Image = Properties.Resources.SkypeMe;
                toolStripStatusLabel1.Text = "Skype Me!";
            }

            if (status == TUserStatus.cusAway)
            {
                BotStatus = "AW";

                toolStripStatusLabel1.Image = Properties.Resources.Away;
                toolStripStatusLabel1.Text = "Away";
            }

            if (status == TUserStatus.cusNotAvailable)
            {
                BotStatus = "NA";

                toolStripStatusLabel1.Image = Properties.Resources.NotAvailable;
                toolStripStatusLabel1.Text = "Not Availble";
            }

            if (status == TUserStatus.cusDoNotDisturb)
            {
                BotStatus = "DD";

                toolStripStatusLabel1.Image = Properties.Resources.DoNotDisturb;
                toolStripStatusLabel1.Text = "Do Not Disturb";
            }

            if (status == TUserStatus.cusLoggedOut)
            {
                BotStatus = "NR";

                toolStripStatusLabel1.Image = Properties.Resources.StatusPending;
                toolStripStatusLabel1.Text = "Connecting to Skype ...";
            }
        }

        /* Pie ienkoiem zvaniem, ja tas nepiecieam noliekam trubu */
        public void Skype_CallStatus(Call call, TCallStatus status)
        {
            if (checkBox1.Checked == true)
            {
                if ((status > TCallStatus.clsUnplaced) && (status < TCallStatus.clsOnHold) && (status != TCallStatus.clsFailed))
                {
                    call.Finish();
                }
            }
        }

        /* BOTa dienasgrmata */
        string write_diary (string line)
        {
            DateTime logtime = DateTime.Now;

            String strMonth = logtime.Month.ToString();
            if (strMonth.Length <= 1) { strMonth = "0" + strMonth; }
            String strDay = logtime.Day.ToString();
            if (strDay.Length <= 1) { strDay = "0" + strDay; }
            String strYear = logtime.Year.ToString();
            String strHour = logtime.Hour.ToString();
            if (strHour.Length <= 1) { strHour = "0" + strHour; }
            String strMinute = logtime.Minute.ToString();
            if (strMinute.Length <= 1) { strMinute = "0" + strMinute; }
            String strSecond = logtime.Second.ToString();
            if (strSecond.Length <= 1) { strSecond = "0" + strSecond; }

            string inLOG = "[" + strMonth + "." + strDay + "." + strYear + ". - " + strHour + ":" + strMinute + ":" + strSecond + "]";
            bot_diary.AppendText(inLOG + " " + line + Environment.NewLine);
            bot_diary.ScrollToCaret();

            return "";
        }

        /* Apstrdjam ienkos sarakstes zias */
        public void Skype_Message(IChatMessage ichatmessage, TChatMessageStatus Status)
        {
            string sMessage = ichatmessage.Body.ToString();

            int size = sMessage.IndexOf(" ", 0);
            bool procced_msg = false;

            string sCommand;
            string sReplay;

            sCommand = sMessage;

            if (size > 1)
            {
                sCommand = sMessage.Substring(0, size);
                sMessage = sMessage.Remove(0, size + 1);
            }

            sCommand = sCommand.ToLower();

            chat = skype.get_Chat(ichatmessage.ChatName);

            if (Status == TChatMessageStatus.cmsReceived)
            {
                procced_msg = true;
                FindReadBug = "";
            }
            else
            {
                if (Status == TChatMessageStatus.cmsRead)
                {
                    if (FindReadBug != "")
                    {
                        string nowRead = ichatmessage.Body.ToString() + "||" + chat.Name.ToString();

                        if (FindReadBug == nowRead)
                        {
                            procced_msg = true;
                            FindReadBug = "";
                        }
                        else
                        {
                            FindReadBug = "";
                        }
                    }
                    else
                    {
                        FindReadBug = ichatmessage.Body.ToString() + "||" + chat.Name.ToString();
                    }
                }
            }

            if (procced_msg)
            {
                bool inList = false;

                for (int Y = 0; Y < listBox6.Items.Count; Y++)
                {
                    if (listBox6.Items[Y].ToString() == ichatmessage.FromHandle.ToString())
                    {
                        int MsgInMin = Convert.ToInt16(listBox7.Items[Y]) + 1;

                        if (MsgInMin > numericUpDown2.Value)
                        {
                            skype.get_User(ichatmessage.FromHandle.ToString()).IsBlocked = true;
                        }
                        else
                        {
                            listBox7.Items[Y] = Convert.ToString(MsgInMin);
                        }

                        inList = true;
                    }
                }

                if (!inList)
                {
                    listBox6.Items.Add(ichatmessage.FromHandle.ToString());
                    listBox7.Items.Add("1");
                }

                write_diary("Recieved new chat message (ID:" + ichatmessage.Id.ToString() + ")");

                bool AA_already = false;

                for (int I = 0; I < listBox1.Items.Count; I++)
                {
                    if ((sCommand.ToString() == Convert.ToString(listBox1.Items[I])) && (BotStatus == Convert.ToString(listBox3.Items[I])))
                    {
                        string responseset = Convert.ToString(listBox2.Items[I]);
                        string sURL = Convert.ToString(listBox2.Items[I]);

                        sURL = sURL.Replace("[SU]", "su="  + ichatmessage.FromHandle.ToString());
                        sURL = sURL.Replace("[MSG]", "msg=" + sMessage);

                        int sizeofresponse = responseset.IndexOf("//", 0);

                        if (sizeofresponse <= 1)
                        {
                            sReplay = Convert.ToString(listBox2.Items[I]);
                        }
                        else
                        {
                            sReplay = WebString(sURL, true);
                        }

                        //sReplay = sReplay.Replace("<br>", "\n");

                        listBox4.Items.Add(sReplay + ":|:[]" + ichatmessage.ChatName);
                        AA_already = true;

                        write_diary("Answered to chat message (ID:" + ichatmessage.Id.ToString() + ")");
                    }
                }

                if (!AA_already)
                {
                    for (int J = 0; J < treeView1.Nodes.Count; J++)
                    {
                        if (sCommand.ToString() == treeView1.Nodes[J].Text)
                        {
                            bool Add_new_subscription = true;
                            for (int S = 0; S < treeView1.Nodes[J].Nodes[1].Nodes.Count; S++)
                            {
                                if (ichatmessage.ChatName.ToString() == treeView1.Nodes[J].Nodes[1].Nodes[S].Tag.ToString())
                                {
                                    treeView1.Nodes[J].Nodes[1].Nodes.RemoveAt(S);

                                    sReplay = WebString(treeView1.Nodes[J].Nodes[0].Text + "&sub=0", true);
                                    listBox4.Items.Add(sReplay + ":|:[]" + ichatmessage.ChatName);

                                    Add_new_subscription = false;

                                    button5.Enabled = true;
                                    button6.Enabled = true;

                                    write_diary("Chat '" + ichatmessage.ChatName + "' unscribed from '" + treeView1.Nodes[J].Text.ToString() + "'");
                                }
                            }

                            if (Add_new_subscription)
                            {
                                treeView1.Nodes[J].Nodes[1].Nodes.Add(ichatmessage.FromHandle.ToString());
                                treeView1.Nodes[J].Nodes[1].Nodes[(treeView1.Nodes[J].Nodes[1].Nodes.Count - 1)].Tag = ichatmessage.ChatName;

                                sReplay = WebString(treeView1.Nodes[J].Nodes[0].Text + "&sub=1", true);
                                listBox4.Items.Add(sReplay + ":|:[]" + ichatmessage.ChatName);

                                button5.Enabled = true;
                                button6.Enabled = true;

                                write_diary("Chat '" + ichatmessage.ChatName + "' subcribed for '" + treeView1.Nodes[J].Text.ToString() + "'");
                            }
                        }
                    }
                }
            }
        }

        /* Apstrdjam HTTP pieprasjumus uz serveriem */
        string WebString(string sURL, bool Return_error)
        {
            try
            {
                WebRequest wrGETURL;
                wrGETURL = WebRequest.Create(sURL);

                Stream objStream;
                objStream = wrGETURL.GetResponse().GetResponseStream();

                StreamReader objReader = new StreamReader(objStream);
                string sLine = "";
                sLine = objReader.ReadLine();
                if (sLine != null)
                {
                    return sLine;
                }
                else
                {
                    return "";
                }
            }

            catch
            {
                if (Return_error)
                {
                    return textBox3.Text;
                }
                else
                {
                    return "";
                }
            }
        }

        /* Nosaka vai abi lauki AA ir aizpildti*/
        string canwrite()
        {
            if (this.textBox1.Text == "")
            {
                this.button1.Enabled = false;
            }
            else
            {
                if (this.textBox2.Text == "")
                {
                    this.button1.Enabled = false;
                }
                else
                {
                    this.button1.Enabled = true;
                }
            }

            return "";
        }

        /* Nosaka vai visi lauki jauna subscription izveidoan ir aizpildti */
        string canwrite_subscr()
        {
            if ((textBox5.Text != "") && (textBox4.Text != ""))
            {
                button10.Enabled = true;
            }
            else
            {
                button10.Enabled = false;
            }
            return "";
        }

        /* Ieldjam konfigurciju */
        string LoadConfig(string automatic)
        {
            this.listBox1.Items.Clear();
            this.listBox2.Items.Clear();
            this.treeView1.Nodes.Clear();
            this.listBox5.Items.Clear();
            this.listBox3.Items.Clear();
            string EnterFilename;

            OpenFileDialog Open = new OpenFileDialog();
            Open.Filter = "Configuration file|*.conf";

            try
            {
                if (automatic == "")
                {
                    Open.ShowDialog();
                    EnterFilename = Convert.ToString(Open.FileName);
                }
                else
                {
                    EnterFilename = automatic;
                }

                SaveFile = EnterFilename;

                StreamReader Import = new StreamReader(EnterFilename);
                string OneConfLine;

                while (Import.Peek() >= 0)
                {
                    OneConfLine = Convert.ToString(Import.ReadLine());

                    string sstatus;
                    string perefix;
                    string back;

                    int stat = OneConfLine.IndexOf("=", 0);

                    sstatus = OneConfLine.Substring(0, stat);
                    OneConfLine = OneConfLine.Remove(0, stat + 1);

                    int size = OneConfLine.IndexOf(" ", 0);

                    perefix = OneConfLine.Substring(0, size);
                    back = OneConfLine.Remove(0, size + 1);

                    if (perefix != "")
                    {
                        if (back != "")
                        {
                            if ((sstatus == "ON") || (sstatus == "AW") || (sstatus == "SM") || (sstatus == "NA") || (sstatus == "DD"))
                            {
                                listBox1.Items.Add(perefix);
                                listBox2.Items.Add(back);
                                listBox3.Items.Add(sstatus);
                            }

                            if (sstatus == "SUB")
                            {
                                treeView1.Nodes.Add(perefix);
                                string[] stuff_of_back = back.Split(new Char[] { ' ' });

                                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes.Add(stuff_of_back[0]);
                                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes.Add("Subscribers");
                                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes[1].Tag = "";
                                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Tag = stuff_of_back[1];

                                listBox5.Items.Add(stuff_of_back[1]);

                                if (stuff_of_back.Length == 3)
                                {
                                    string[] iteming = stuff_of_back[2].Split(new Char[] { '*' });

                                    for (int i = 0; i < (iteming.Length - 1); i++)
                                    {
                                        string[] one_item = iteming[i].Split(new Char[] { '@' });
                                        treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes[1].Nodes.Add(one_item[0]);
                                        
                                        int indexings = (treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes[1].Nodes.Count - 1);
                                        treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes[1].Nodes[indexings].Tag = one_item[1];
                                    }
                                }
                            }
                        }
                    }
                }

                Import.Close();

                return "";
            }
            catch (Exception ex)
            {
                if (automatic != "")
                {
                    Properties.Settings.Default.AutoConf = "";
                    checkBox3.Checked = false;
                }

                MessageBox.Show(Convert.ToString(ex.Message));
                return "";
            }
        }

        /* Saraksta dzinjs */
        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            listBox2.TopIndex = listBox1.TopIndex;
            listBox2.SelectedIndex = listBox1.SelectedIndex;

            if (DoNotChange == false)
            {

                if (listBox1.SelectedIndex > -1)
                {
                    if (listBox3.Items[listBox1.SelectedIndex].ToString() == "ON")
                    {
                        pictureBox1.Image = Properties.Resources.Online;
                    }

                    if (listBox3.Items[listBox1.SelectedIndex].ToString() == "AW")
                    {
                        pictureBox1.Image = Properties.Resources.Away;
                    }

                    if (listBox3.Items[listBox1.SelectedIndex].ToString() == "NA")
                    {
                        pictureBox1.Image = Properties.Resources.NotAvailable;
                    }

                    if (listBox3.Items[listBox1.SelectedIndex].ToString() == "SM")
                    {
                        pictureBox1.Image = Properties.Resources.SkypeMe;
                    }

                    if (listBox3.Items[listBox1.SelectedIndex].ToString() == "DD")
                    {
                        pictureBox1.Image = Properties.Resources.DoNotDisturb;
                    }
                }
            }
            else
            {
                DoNotChange = false;
            }

            if (listBox1.SelectedIndex > -1)
            {
                button2.Enabled = true;
                button3.Enabled = true;
            }
        }

        /* Saglabjam konfigurciju */
        string SaveConfig(string SaveIn)
        {
            StreamWriter Write;
            SaveFileDialog Open = new SaveFileDialog();

            string sOneLineString;
            try
            {
                if (SaveIn == "")
                {
                    Open.Filter = ("Configuration file|*.conf");
                    Open.ShowDialog();

                    if (Open.FileName != "")
                    {
                        SaveFile = Open.FileName;
                    }

                    SaveIn = Open.FileName;
                }

                Write = new StreamWriter(SaveIn);

                for (int I = 0; I < listBox1.Items.Count; I++)
                {
                    sOneLineString = Convert.ToString(listBox3.Items[I]) + "=" + Convert.ToString(listBox1.Items[I]) + " " + Convert.ToString(listBox2.Items[I]);
                    Write.WriteLine(sOneLineString);
                }

                for (int J = 0; J < treeView1.Nodes.Count; J++)
                {
                    sOneLineString = "SUB=" + treeView1.Nodes[J].Text + " " + treeView1.Nodes[J].Nodes[0].Text + " " + treeView1.Nodes[J].Tag.ToString() + " ";

                    if (treeView1.Nodes[J].Nodes[1].Nodes.Count > 0)
                    {
                        for (int E = 0; E < treeView1.Nodes[J].Nodes[1].Nodes.Count; E++)
                        {
                            sOneLineString = sOneLineString + treeView1.Nodes[J].Nodes[1].Nodes[E].Text + "@" + treeView1.Nodes[J].Nodes[1].Nodes[E].Tag.ToString() + "*";
                        }
                    }

                    Write.WriteLine(sOneLineString);
                }

                Write.Close();
                return "";
            }
            catch (Exception ex)
            {
                MessageBox.Show(Convert.ToString(ex.Message));
                return "";
            }
        }

        /* Ierakstm informciju par pieslganos BOTa dienasgrmat */
        string ConnectLog()
        {
            if (ConnectStatusChanged == true)
            {
                if (BotStatus == "NR")
                {
                    write_diary("Connecting to Skype ...");
                }
                else
                {
                    write_diary("Succsesfuly connected!");
                }

                ConnectStatusChanged = false;
            }
            return "";
        }

        /* Statusa un izstmo ziu dzinjs */ 
        private void timer1_Tick(object sender, EventArgs e)
        {
            ConnectLog();
            
            if (BotStatus == "NR")
            {
                SkypeAttaching();
            }
            else
            {
                if (listBox4.Items.Count > 0)
                {
                    string linetoprocess = listBox4.Items[0].ToString();

                    string sMsg;
                    string sendTo;

                    int size = linetoprocess.IndexOf(":|:[]", 0);

                    sMsg = linetoprocess.Substring(0, size);
                    sendTo = linetoprocess.Remove(0, size + 5);

                    chat = skype.get_Chat(sendTo);

                    sMsg = sMsg.Replace("<br>", "\n");

                    chat.SendMessage(sMsg);

                    if ((chat.Status.ToString() == "chsDialog") || (chat.Status.ToString() == "chsMultiSubscribed"))
                    {
                        listBox4.Items.RemoveAt(0);
                    }
                }
            }
        }

        /* Subscription ziu stana */
        private void timer2_Tick(object sender, EventArgs e)
        {
            if (button6.Enabled)
            {
                SaveConfig(SaveFile);

                button6.Enabled = false;
                button5.Enabled = false;

                write_diary("Automaticly saved configuration file: " + SaveFile);
            }

            for (int I = 0; I < listBox5.Items.Count; I++)
            {
                if ((Convert.ToInt16(listBox5.Items[I]) - 1) == 0)
                {
                    string MSG;

                    MSG = WebString(treeView1.Nodes[I].Nodes[0].Text, false);

                    if ((treeView1.Nodes[I].Nodes[1].Tag.ToString() != MSG) && (MSG != ""))
                    {
                        for (int R = 0; R < treeView1.Nodes[I].Nodes[1].Nodes.Count; R++)
                        {
                            listBox4.Items.Add(MSG + ":|:[]" + treeView1.Nodes[I].Nodes[1].Nodes[R].Tag.ToString());
                        }
                        
                        treeView1.Nodes[I].Nodes[1].Tag = MSG;

                        write_diary("Subscription message about '" + treeView1.Nodes[I].Text.ToString() + "' putted in outbox");
                    }

                    listBox5.Items[I] = treeView1.Nodes[I].Tag.ToString();
                }
                else
                {
                    int increse = Convert.ToInt16(listBox5.Items[I]) - 1;
                    listBox5.Items[I] = Convert.ToString(increse);
                }
            }

            if (SaveFile != "")
            {
                StreamWriter Write;
                Write = new StreamWriter(SaveFile + ".bssd");

                for (int R = 0; R < treeView1.Nodes.Count; R++)
                {
                    Write.WriteLine(treeView1.Nodes[R].Nodes[1].Tag.ToString());
                }

                Write.Close();
            }
        }

        /* Tray Ikona */
        private void notifyIcon1_DoubleClick(object sender, MouseEventArgs e)
        {
            Show();
            WindowState = FormWindowState.Normal;
        }

        /* eki */
        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                Properties.Settings.Default.NotAllowIncoming = true;
            }
            else
            {
                Properties.Settings.Default.NotAllowIncoming = false;
            }
        }
        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox2.Checked == true)
            {
                Properties.Settings.Default.BringSkypeToLife = true;
            }
            else
            {
                Properties.Settings.Default.BringSkypeToLife = false;
            }
        }
        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox3.Checked != true)
            {
                Properties.Settings.Default.AutoConf = "";
            }
            else
            {
                OpenFileDialog Open = new OpenFileDialog();
                Open.Filter = "Configuration file|*.conf";

                try
                {
                    Open.ShowDialog();
                    if (Convert.ToString(Open.FileName) != "")
                    {
                        Properties.Settings.Default.AutoConf = Convert.ToString(Open.FileName);
                    }
                    else
                    {
                        checkBox3.Checked = false;
                    }
                }

                catch (Exception ex)
                {
                    MessageBox.Show(Convert.ToString(ex.Message));
                }
            }
        }
        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            ChangeFileTransfStatus(checkBox4.Checked);
            Properties.Settings.Default.NotAllowFT = checkBox4.Checked;
        }
        private void checkBox5_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox5.Checked == true)
            {
                Properties.Settings.Default.AcceptAR = true;
            }
            else
            {
                Properties.Settings.Default.AcceptAR = false;
            }
        }
        private void checkBox6_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox6.Checked)
            {
                Properties.Settings.Default.AutoSubStart = true;
            }
            else
            {
                Properties.Settings.Default.AutoSubStart = false;
            }
        }

        /* Ierakstu lauki */
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            canwrite();
        }
        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            canwrite();
        }
        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            if (textBox3.Text != "")
            {
                button7.Enabled = true;
            }
            else
            {
                button7.Enabled = false;
            }
        }
        private void textBox4_TextChanged(object sender, EventArgs e)
        {
            canwrite_subscr();
        }
        private void textBox5_TextChanged(object sender, EventArgs e)
        {
            canwrite_subscr();
        }

        /* POGAS */
        private void button1_Click(object sender, EventArgs e)
        {
            if (button1.Text != "Change")
            {
                string perefix;

                perefix = textBox1.Text.ToLower();
                perefix = perefix.Replace(" ", "");

                listBox1.Items.Add(perefix);
                listBox2.Items.Add(textBox2.Text);
                listBox3.Items.Add(pictureBox1.Tag.ToString());

                textBox1.Text = "";
                textBox2.Text = "";

                button1.Enabled = false;
                button5.Enabled = true;
                if (SaveFile != "")
                {
                    button6.Enabled = true;
                }
            }
            else
            {
                listBox1.Items[listBox1.SelectedIndex] = textBox1.Text;
                listBox2.Items[listBox1.SelectedIndex] = textBox2.Text;
                listBox3.Items[listBox1.SelectedIndex] = pictureBox1.Tag.ToString();

                DoNotChange = true;

                button1.Text = "Add";
                button1.Enabled = false;

                button2.Text = "Remove";
                button2.Enabled = true;

                button3.Enabled = true;
                button4.Enabled = true;
                button5.Enabled = true;

                if (SaveFile != "")
                {
                    button6.Enabled = true;
                }

                textBox1.Text = "";
                textBox2.Text = "";

                listBox1.Enabled = true;
            }

        }
        private void button2_Click(object sender, EventArgs e)
        {
            if (button2.Text != "Cancel")
            {
                DoNotChange = true;

                listBox3.Items.RemoveAt(listBox1.SelectedIndex);
                listBox2.Items.RemoveAt(listBox1.SelectedIndex);
                listBox1.Items.Remove(listBox1.SelectedItem);

                button2.Enabled = false;
                button3.Enabled = false;
                button5.Enabled = true;

                if (SaveFile != "")
                {
                    button6.Enabled = true;
                }
            }
            else
            {
                button1.Text = "Add";
                button1.Enabled = false;

                button2.Text = "Remove";
                button2.Enabled = true;

                button3.Enabled = true;
                button4.Enabled = true;

                textBox1.Text = "";
                textBox2.Text = "";

                listBox1.Enabled = true;
            }
        }
        private void button3_Click(object sender, EventArgs e)
        {
            button1.Text = "Change";
            button1.Enabled = true;

            button2.Text = "Cancel";
            button2.Enabled = true;

            button3.Enabled = false;
            button4.Enabled = false;

            listBox1.Enabled = false;

            textBox1.Text = listBox1.SelectedItem.ToString();
            textBox2.Text = listBox2.Items[listBox1.SelectedIndex].ToString();
            pictureBox1.Tag = listBox3.Items[listBox1.SelectedIndex].ToString();
        }
        private void button4_Click(object sender, EventArgs e)
        {
            if (button5.Enabled == true)
            {

                string aswer_to_quest;
                aswer_to_quest = MessageBox.Show("In configuration file have been made changes, if you will\nload other file, you will lose all your work. Continue?", "Changes in configuration file!", MessageBoxButtons.YesNo, MessageBoxIcon.Warning).ToString();
                if (aswer_to_quest == "Yes")
                {
                    LoadConfig("");
                    LoadBackup();

                    button5.Enabled = false;
                }

            }
            else
            {
                LoadConfig("");
                button5.Enabled = false;
            }
        }
        private void button5_Click(object sender, EventArgs e)
        {
            SaveConfig("");
            button5.Enabled = false;
            button6.Enabled = false;
        }
        private void button6_Click_1(object sender, EventArgs e)
        {
            SaveConfig(SaveFile);
            button6.Enabled = false;
        }
        private void button7_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.RespondToInternetError = textBox3.Text;
            button7.Enabled = false;
        }
        private void button8_Click(object sender, EventArgs e)
        {

            button10.Text = "Change";
            button9.Text = "Cancel";

            button9.Enabled = true;
            button10.Enabled = true;

            button8.Enabled = false;

            treeView1.Enabled = false;

            textBox5.Text = treeView1.Nodes[treeView1.SelectedNode.Index].Text;
            numericUpDown1.Value = Convert.ToInt16(treeView1.Nodes[treeView1.SelectedNode.Index].Tag);

            textBox4.Text = treeView1.Nodes[treeView1.SelectedNode.Index].Nodes[0].Text;
        }
        private void button9_Click(object sender, EventArgs e)
        {
            if (button9.Text == "Remove")
            {
                listBox5.Items.RemoveAt(treeView1.SelectedNode.Index);
                treeView1.Nodes[treeView1.SelectedNode.Index].Remove();

                button9.Enabled = false;
                button8.Enabled = false;

                button5.Enabled = true;
                if (SaveFile != "")
                {
                    button6.Enabled = true;
                }
            }
            else
            {
                textBox4.Text = "http://";
                textBox5.Text = "";
                numericUpDown1.Value = 1;

                button10.Text = "Add";
                button9.Text = "Remove";

                button9.Enabled = false;

                treeView1.Enabled = true;
            }
        }
        private void button10_Click(object sender, EventArgs e)
        {
            if (button10.Text == "Add")
            {
                treeView1.Nodes.Add(textBox5.Text);
                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Tag = numericUpDown1.Value.ToString();
                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes.Add(textBox4.Text.ToString());
                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes.Add("Subscribers");

                treeView1.Nodes[(treeView1.Nodes.Count - 1)].Nodes[1].Tag = "";

                listBox5.Items.Add(numericUpDown1.Value.ToString());

                textBox4.Text = "http://";
                textBox5.Text = "";
                numericUpDown1.Value = 1;

                button5.Enabled = true;
                if (SaveFile != "")
                {
                    button6.Enabled = true;
                }
            }
            else
            {
                treeView1.Nodes[treeView1.SelectedNode.Index].Text = textBox5.Text;
                treeView1.Nodes[treeView1.SelectedNode.Index].Tag = numericUpDown1.Value.ToString();

                treeView1.Nodes[treeView1.SelectedNode.Index].Nodes[0].Text = textBox4.Text;

                textBox4.Text = "http://";
                textBox5.Text = "";
                numericUpDown1.Value = 1;

                button10.Text = "Add";
                button9.Text = "Remove";

                button9.Enabled = false;

                treeView1.Enabled = true;

                button5.Enabled = true;
                if (SaveFile != "")
                {
                    button6.Enabled = true;
                }
            }
        }
        private void button11_Click(object sender, EventArgs e)
        {
            if (button11.Text == "Start service")
            {
                timer2.Enabled = true;
                button11.Text = "Stop service";
            }
            else
            {
                timer2.Enabled = false;
                button11.Text = "Start service";
            }
        }
        private void button12_Click(object sender, EventArgs e)
        {
            for (int I = 0; I < listBox5.Items.Count; I++)
            {
                string MSG;

                MSG = WebString(treeView1.Nodes[I].Nodes[0].Text, false);
                treeView1.Nodes[I].Nodes[1].Tag = MSG;
            }
        }

        /* Statusa izvles menu */
        private void Online_menu_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.Online;
            pictureBox1.Tag = "ON";
        }
        private void SkypeMe_menu_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.SkypeMe;
            pictureBox1.Tag = "SM";
        }
        private void Away_menu_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.Away;
            pictureBox1.Tag = "AW";
        }
        private void NotAvailble_menu_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.NotAvailable;
            pictureBox1.Tag = "NA";
        }
        private void DoNotDisturb_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = Properties.Resources.DoNotDisturb;
            pictureBox1.Tag = "DD";
        }

        /* Subscriptions datu bze */
        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (treeView1.SelectedNode.Level == 0)
            {
                button9.Enabled = true;
                button8.Enabled = true;
            }
            else
            {
                button9.Enabled = false;
                button8.Enabled = false;
            }
        }

        /* Attram iespjamo banu datubazi */
        private void timer3_Tick(object sender, EventArgs e)
        {
            listBox6.Items.Clear();
            listBox7.Items.Clear();
        }

        /* Izvlamies kad banot */
        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.BlockUserMsg = Convert.ToInt16(numericUpDown2.Value);
        }
        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.BlockUserTime = Convert.ToInt16(numericUpDown3.Value);
            timer3.Interval = Convert.ToInt32(numericUpDown3.Value * 1000);
        }
    }
}